/*---------------------------------------------------------------------

acquigen.h

This file is part of CytoPacq

Copyright (C) 2007-2013 -- Centre for Biomedical Image Analysis (CBIA)

CytoPacq is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

CytoPacq is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with CytoPacq. If not, see <http://www.gnu.org/licenses/>.

Author: David Svoboda

Description: A module simulating signal acquisition using CCD detector. It performs e.g. sampling, noise addition, etc.

-------------------------------------------------------------------------*/

#ifndef _ACQUIGEN_
#define _ACQUIGEN_

#include <i3d/image3d.h>
#include <i3d/transform.h>
#include <ini/iniparser.h>

//----------------------------------------------------------------------
void GetFinalResolution(const IniHandler &params, 
								i3d::Resolution &res);

//----------------------------------------------------------------------
template <class PHOTONS, class ELECTRONS, class ADU>
void CallAcquigen(const IniHandler &params, 
						const i3d::Image3d<PHOTONS> &image_in,
						i3d::Image3d<ADU> &image_out,
						i3d::SamplingMode sampling = i3d::LANCZOS);
//----------------------------------------------------------------------

#endif
