/*---------------------------------------------------------------------

cytogen.h

This file is part of CytoPacq

Copyright (C) 2007,2008 -- Centre for Biomedical Image Analysis (CBIA)

CytoPacq is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

CytoPacq is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with CytoPacq. If not, see <http://www.gnu.org/licenses/>.

Author: David Svoboda

Description: A module which creates an initial empty image. Afterwards, it fills it with user selected digital phantom(s). The definition of individual digital phantoms is implemented as a removable plugin.

-------------------------------------------------------------------------*/

#ifndef _CYTOGEN_
#define _CYTOGEN_

#include <i3d/image3d.h>

#include "ini/iniparser.h"

typedef i3d::GRAY16 LABEL_TYPE;

//------------------------------------------------------------------

template <class T, class L> 
void CallCytogen(const IniHandler &params, 
					  i3d::Image3d<T> &img_phantoms, 
					  i3d::Image3d<L> &img_labels,
					  const char *plugin_directory);

template <class T>
void CreateEmptyImage(const IniHandler &params, 
							 i3d::Image3d<T> &synth);

//------------------------------------------------------------------

#endif

